;asm datatype for YAS 2.0
;by Aaron Curtis and Jonah Cohen

#define asmhighc(x) $f400+x-asm_comment
#define asmhighi(x) $f400+x-asm_icon
#define asmhighd(x) $f400+x-asm_detect
#define asmrelptr(x) x-$-1			;relative pointer

	.db 0							;low priority
	.db $12							;detects programs
	.db "asm"						;3 byte descripiton

	.dw _exec_assembly

	.dw asm_enddetect-asm_detect
	.dw asmrelptr(asm_detect)

	.dw asm_endcomment-asm_comment
	.dw asmrelptr(asm_comment)

	.dw asm_endicon-asm_icon
	.dw asmrelptr(asm_icon)



asm_detect:
    call _GET_DATA_SIZE_DE_INC  ;ahl=ahl+2, de=(ahl)
    push hl
    push af
    call _HAVE_EXTEND           ;check if has asm tokens (input: ahl is the start of the data+2)
    pop af
    pop hl
    rr c                        ;outputs: c=1 if bad, 0 if good
    ret c
    ld e,a
    ld a,d
    cp $29                      ;locked basic
    scf
    ret z
    ld a,e
    call _GET_DATA_SIZE_DE_INC
    call _GET_DATA_SIZE_DE_INC 
    ld hl,$cbfd
    call _cphlde
    scf
    ret z
    or a
    ret
asm_enddetect:


asm_comment:
	in a,(6)
	out (5),a
	inc a
	out (6),a
	ld de,-$4000+2				;+2 to skip the asm token
	add hl,de
	ld c,l
	ld b,h

	ld a,(hl)					;check for nop / jp
	or a
	jr nz,asm_nocomment
	inc hl
	ld a,(hl)
	cp $c3
	jr nz,asm_nocomment

	ld de,5						;get the comment pointer
	add hl,de
	call $0033					;ld hl,(hl) ; a=h
	or l						;return if they used a .dw 0
	jr z,asm_nocomment
	ld de,$10000-_asm_exec_ram	;negative _asm_exec_ram
	add hl,de
	add hl,bc

	ld de,$f500					;copy comment to somewhere else...
	push de
copycomment:
		ld a,(hl)
		ldi
		or a
		jr nz,copycomment
	pop hl
	jr asm_commentfound

asm_nocomment:
	scf
asm_commentfound:
	ld a,$0d					;can't forget this :)
	out (5),a
	jp _ram_page_1
asm_endcomment:


asm_icon:
	in a,(6)
	out (5),a
	inc a
	out (6),a
	ld de,-$4000+2
	add hl,de
	ld c,l
	ld b,h

	ld a,(hl)
	or a
	jr nz,asm_defaulticon
	inc hl
	ld a,(hl)
	cp $c3
	jr nz,asm_defaulticon

	inc hl
	inc hl
	inc hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	inc hl
	inc hl
	push hl
		ld hl,-$0001			;$0001 = minimum version number for icons
		add hl,de
	pop hl
	jr nc,asm_defaulticon

	call $0033
	or l
	jr z,asm_defaulticon
	ld de,$10000-_asm_exec_ram	;negative _asm_exec_ram
	add hl,de
	add hl,bc

asm_loadicon:	
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld de,$f500
	push de
	push bc
	xor a
asm_iconcount:
		add a,c
		djnz asm_iconcount

asm_iconcopy:
		ldi
		dec a
		jr nz,asm_iconcopy
	pop bc
	pop hl

	ld a,$0d
	out (5),a
	jp _ram_page_1

asm_defaulticon:
    ld hl,asmhighi(asm_default_icon)
    jr asm_loadicon

asm_default_icon:
.db 6,1
.db %10000000
.db %01100000
.db %00110000
.db %00011100
.db %00011010
.db %00001110
asm_endicon:

.end
